<template>
  <div class="flex min-h-screen flex-1 flex-col bg-gray-100">
    <slot name="header" />

    <div v-if="hasCustomContent" key="custom" class="w-full grow bg-white">
      <slot />
    </div>
    <div v-else key="default" class="w-full grow py-6 lg:py-8 xl:py-12">
      <ui-container
        :has-sidebar="hasSidebar"
        sidebar-tag="aside"
        tag="main"
        has-page-padding
      >
        <template #sidebar>
          <ui-box>
            <div
              class="mx-auto"
              :class="{
                'prose md:prose-lg lg:prose-xl': !noProse,
              }"
            >
              <slot name="sidebar" />
            </div>
          </ui-box>
        </template>

        <ui-box>
          <slot name="preMain" />
          <article
            class="mx-auto"
            :class="{
              'prose md:prose-lg lg:prose-xl': !noProse,
            }"
          >
            <slot />
          </article>
        </ui-box>
      </ui-container>
    </div>

    <slot name="footer" />
  </div>
</template>

<script lang="ts" setup>
import UiBox from './Box.vue'
import UiContainer from './Container.vue'

defineOptions({
  name: 'UiPage',
})

defineProps({
  noProse: {
    type: Boolean,
    default: false,
  },

  hasSidebar: {
    type: Boolean,
    default: false,
  },

  hasCustomContent: {
    type: Boolean,
    default: false,
  },
})
</script>
